#include "TextProcessor.h"

TextProcessor::TextProcessor(QObject *parent) : QObject(parent),
    _action(NoAction)
{
    // ToDo: connect signals to notify about processedText property change
}

QString TextProcessor::text() const
{
    return this->_text;
}

TextProcessor::Action TextProcessor::action() const
{
    return this->_action;
}

QString TextProcessor::processedText() const
{
    switch (this->_action) {
    case TextProcessor::MakeUppercase:
        return this->_text.toUpper();
    case TextProcessor::MakeLowercase:
        return this->_text.toLower();
    default:
        return this->_text;
    }
}

QString TextProcessor::prepend(const QString &string) {
    this->_text = string + this->_text;
    // ToDo: notify about text property change
    return this->_text;
}

void TextProcessor::setText(const QString &text)
{
    this->_text = text;
    // ToDo: notify about text property change
}

void TextProcessor::setAction(Action action)
{
    this->_action = action;
    // ToDo: notify about action property change
}
